#define	Key1	0
#define	Key2	3
#define	Key3	4
#define	Key4	5
#define	KeyPort	PORTB

.def	Arg1HH=	R4
.def	Arg1HL=	R5
.def	Arg1LH=	R6
.def	Arg1LL=	R7

.def	Arg2HH=	R8
.def	Arg2HL=	R9
.def	Arg2LH=	R10
.def	Arg2LL=	R11

.def	ResHH=	R12
.def	ResHL=	R13
.def	ResLH=	R14
.def	ResLL=	R15

.def	Input=	R16
.def	Temp=	R17
.def	Status=	R25


.macro	add16	;@0..1 = @0..1 + @2..3
	add	@1,@3
	adc	@0,@2
.endmacro

.macro	add32	;@0..3 = @0..3 + @4..7
	add	@3,@7
	adc	@2,@6
	adc	@1,@5
	adc	@0,@4
.endmacro



.macro	sub16	;@0..1 = @0..1 - @2..3
	sub	@1,@3
	sbc	@0,@2
.endmacro

.macro	sub32	;@0..3 = @0..3 - @4..7
	sub	@3,@7
	sbc	@2,@6
	sbc	@1,@5
	sbc	@0,@4
.endmacro


.macro	cp16	;@0..1 - @2..3
	cp	@1,@3
	cpc	@0,@2
.endmacro

.macro	cp24	;@0..2 - @3..5
	cp	@2,@5
	cpc	@1,@4
	cpc	@0,@3
.endmacro

.macro	cp32	;@0..3 - @4..7
	cp	@3,@7
	cpc	@2,@6
	cpc	@1,@5
	cpc	@0,@4
.endmacro
